import { TransCreateFn } from "..";

export const move: TransCreateFn = () => ({
  mousemove(e) {
    const { compEl, module, transEvent, currComp } = this;
    const { helper } = module;

    compEl.style.left = helper.designToNaturalSize(
      currComp.value.position[0] + transEvent.offsetX * 2
    );
    compEl.style.top = helper.designToNaturalSize(
      currComp.value.position[1] + transEvent.offsetY * 2
    );
  },
  mouseup() {
    const { transEvent, currComp } = this;
    currComp.value.position[0] += transEvent.offsetX * 2;
    currComp.value.position[1] += transEvent.offsetY * 2;
  },
});
