import { mapValuesDeep } from "@/utils";
import { EditorModule } from "..";
import { DesignComp } from "../../objects/DesignTemp/DesignComp";
import { createCompStyle } from "../../objects/DesignTemp/creates/createCompStyle";
import { Layout } from "../../typings";

export const helpers = EditorModule.helper({
  designToNaturalSize(value: number) {
    return value / 100 + "rem";
  },
  findComp(compId: string) {
    const { compMap } = this.store.designData;
    const comp = compMap[compId];
    if (comp) return comp;
  },
  findParentComp(compId: string): DesignComp | undefined {
    const comp = this.helper.findComp(compId);
    if (comp) return this.helper.findComp(comp.pid);
  },
  findRootComp(): DesignComp | undefined {
    return this.store.designData.compMap["root"];
  },
  getCompTrees(compId: string) {
    const comps: DesignComp[] = [];
    const getParentComp = (compId: string) => {
      const comp = this.helper.findComp(compId);
      if (comp) {
        comps.unshift(comp);
        getParentComp(comp.pid);
      }
    };
    getParentComp(compId);
    return comps;
  },
  getCompChildIds(comp: DesignComp) {
    return mapValuesDeep(
      comp.children,
      (v) => typeof v === "string",
      (v: string) => v
    );
  },
  createStyle(layout: Partial<Layout>) {
    return createCompStyle(this, layout);
  },
});
