import { nanoid } from "nanoid";
import { Background, ICompKeys, Layout } from "../../typings";
import { cloneDeep } from "lodash";

export class DesignComp {
  declare pid: string; // pid 作为前端临时数据，不存储到服务器，在初始化时关联
  id = nanoid();
  compKey: ICompKeys = "Text";
  value: any = undefined;
  layout: Layout = {};
  background: Background = {};
  children: Record<string, any> & { default?: string[] } = {};

  constructor(data?: Partial<DesignComp>) {
    if (!data) return;
    const newData = cloneDeep(filterObj(data));
    Object.assign(this, newData);
  }
}

function filterObj(obj: any) {
  const filteredObj: any = {};
  Object.keys(obj).forEach((key) => {
    if (obj[key] !== null && obj[key] !== undefined) {
      filteredObj[key] = obj[key];
    }
  });
  return filteredObj;
}
