import { TipIcons } from "../../components/TipIcons";
import { EditorModule } from "../../module";
import { ICompKeys } from "../../typings";
import { DesignComp } from "../DesignTemp/DesignComp";

type CompToolbarItem = {
  component: any;
  value?: (comp: DesignComp) => number;
  onClick: (this: EditorModule, comp: DesignComp) => void;
};

function createToolbars<T extends Record<string, CompToolbarItem>>(obj: T) {
  return obj;
}

const default_toolbars = createToolbars({
  position: {
    component: TipIcons.Position,
    value: (comp) => (comp.layout.position === "absolute" ? 1 : 0),
    onClick(comp) {
      this.actions.setCompPosition(comp);
    },
  },
  delete: {
    component: TipIcons.Delete,
    onClick(comp) {
      this.actions.removeComp(comp.id);
    },
  },
  clearOffset: {
    component: TipIcons.ClearOffset,
    onClick(comp) {
      this.actions.clearCompOffset(comp);
    },
  },
});

export const CompToolbars: Partial<Record<ICompKeys, CompToolbarItem[]>> & {
  default: CompToolbarItem[];
} = {
  default: [
    default_toolbars.position,
    default_toolbars.clearOffset,
    default_toolbars.delete,
  ],
};
