import { TipIcons } from "../../components/TipIcons";
import { EditorModule } from "../../module";
import { ICompKeys } from "../../typings";
import { DesignComp } from "../DesignTemp/DesignComp";

type Action = {
  component: any;
  getValue?: (c: DesignComp) => 0 | 1;
  disable?: (this: EditorModule, c: DesignComp) => boolean;
  onClick: (this: EditorModule, c: DesignComp) => void;
};

export const treeNodeActions: { [name in ICompKeys]?: Action[] } & {
  default: Action[];
} = {
  default: [
    {
      component: TipIcons.Visible,
      getValue: (comp) => (comp.layout.visible !== false ? 1 : 0),
      onClick(comp) {
        this.actions.setCompVisible(comp);
      },
    },
    {
      component: TipIcons.Delete,
      disable(comp) {
        return !this.store.pageCompIds.includes(comp.id);
      },
      onClick(comp) {
        this.actions.removeComp(comp.id);
      },
    },
  ],
  Page: [],
};
