export function mapValuesDeep<T>(
  obj: any,
  isItem: (v: any) => boolean,
  handle: (v: any) => T
) {
  const arr: T[] = [];
  function mapItem(obj: any) {
    if (isItem(obj)) {
      arr.push(handle(obj));
    } else if (obj instanceof Array) {
      obj.forEach(mapItem);
    } else if (obj instanceof Object) {
      Object.values(obj).forEach(mapItem);
    }
  }
  mapItem(obj);
  return arr;
}
